﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using System.ComponentModel;

namespace xamDataChart_TrendLineCustomMarker
{
    public class ScatterDataSample : ScatterDataCollection
    {
        public ScatterDataSample()
        {
            int value = 50;
            for (int i = 0; i < 100; i++)
            {
                double change = ScatterDataGenerator.Random.NextDouble();
                if (change > .5)
                {
                    value += (int)(change * 20);
                }
                else
                {
                    value -= (int)(change * 20);
                }
                value %= 100;
                this.Add(new ScatterDataPoint
                {
                    X = ScatterDataGenerator.Random.Next(i, i + 5),
                    Y = ScatterDataGenerator.Random.Next(value - 50, value + 50)
                });
            }
        }
    }
    public class ScatterDataCollection : ObservableCollection<ScatterDataPoint> { }
    public class ScatterDataPoint
    {
        private double _y;
        public double Y
        {
            get { return _y; }
            set { if (_y == value) return; _y = value; OnPropertyChanged("Y"); }
        }

        private double _x;
        public double X
        {
            get { return _x; }
            set { if (_x == value) return; _x = value; OnPropertyChanged("X"); }
        }
        public new string ToString()
        {
            return String.Format("X {0}, Y {1}", X, Y);
        }

        public event PropertyChangedEventHandler PropertyChanged;
        protected virtual void OnPropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }
    }
    public static class ScatterDataGenerator
    {
        public static Random Random = new Random();
    }
}
